// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// AlignmentParamDlg.cpp : Cve[V t@C
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAlignmentParamDlg _CAO

CAlignmentParamDlg::CAlignmentParamDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAlignmentParamDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAlignmentParamDlg)
	m_searchmode = -1;
	m_precision = -1;
	m_condition = 5;
	m_threshold = 60;
	m_middlethreshold = 50;
	m_wndtouch = FALSE;
	m_searcharea1 = _T("");
	m_searcharea2 = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	pFvxROI = NULL ;
	pFvxROIGSArea = NULL ;

}

CAlignmentParamDlg::~CAlignmentParamDlg()
{
	// CX^X̔j
	if (pFvxROI!=NULL) delete[] pFvxROI;
	if (pFvxROIGSArea!=NULL) delete[] pFvxROIGSArea;
}

void CAlignmentParamDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAlignmentParamDlg)
	DDX_CBIndex(pDX, IDC_SEARCHMODE, m_searchmode);
	DDX_CBIndex(pDX, IDC_PRECISION, m_precision);
	DDX_Text(pDX, IDC_CONDITION, m_condition);
	DDV_MinMaxInt(pDX, m_condition, 1, 9);
	DDX_Text(pDX, IDC_THRESHOLD, m_threshold);
	DDV_MinMaxInt(pDX, m_threshold, 10, 99);
	DDX_Text(pDX, IDC_MIDDLETHRESHOLD, m_middlethreshold);
	DDV_MinMaxInt(pDX, m_middlethreshold, 10, 99);
	DDX_Check(pDX, IDC_WNDTOUCH, m_wndtouch);
	DDX_Text(pDX, IDC_SEARCHAREA1, m_searcharea1);
	DDX_Text(pDX, IDC_SEARCHAREA2, m_searcharea2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAlignmentParamDlg, CDialog)
	//{{AFX_MSG_MAP(CAlignmentParamDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	ON_BN_CLICKED(IDC_SETPATTERN1, OnSetpattern1)
	ON_BN_CLICKED(IDC_SETPATTERN2, OnSetpattern2)
	ON_BN_CLICKED(IDC_SETSEARCHREGION1, OnSetsearchregion1)
	ON_BN_CLICKED(IDC_SETSEARCHREGION2, OnSetsearchregion2)
	ON_BN_CLICKED(IDC_DISPPATTERN1, OnDisppattern1)
	ON_BN_CLICKED(IDC_DISPPATTERN2, OnDisppattern2)
	ON_BN_CLICKED(IDC_SETPATTERNMASK1, OnSetpatternmask1)
	ON_BN_CLICKED(IDC_SETPATTERNMASK2, OnSetpatternmask2)
	ON_BN_CLICKED(IDC_LOADPATTERN1, OnLoadpattern1)
	ON_BN_CLICKED(IDC_LOADPATTERN2, OnLoadpattern2)
	ON_BN_CLICKED(IDC_SAVEPATTERN1, OnSavepattern1)
	ON_BN_CLICKED(IDC_SAVEPATTERN2, OnSavepattern2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAlignmentParamDlg bZ[W nh

BOOL CAlignmentParamDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ

	// TODO: ̈ʒuɏ̕⑫ǉĂ
	CoInitialize( NULL );
	CWnd *pwnd ;
	IUnknown *p_unknown;

	// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
	pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );		// FvxDisplayEx̃nh擾
	p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
	p_unknown->QueryInterface( __uuidof(IFvxDisplayEx2Ptr) , (void**)&m_FvxDisplayEx1 );

	pwnd = GetDlgItem( IDC_FVXDISPLAYEX2 );		// FvxDisplayEx̃nh擾
	p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
	p_unknown->QueryInterface( __uuidof(IFvxDisplayEx2Ptr) , (void**)&m_FvxDisplayEx2 );

	// zŃCX^X𐶐
	pFvxROI = new IFvxROI2Ptr[2] ;
	pFvxROIGSArea = new IFvxROI2Ptr[2] ;

	for ( int i = 0; i < 2 ; i++) {
		pFvxROI[i].CreateInstance(__uuidof( FvxROI ));
		pFvxROIGSArea[i].CreateInstance(__uuidof( FvxROI ));
	}
	
	// fBXvC̏
    m_FvxDisplayEx1->CreateDisplay(1,0); 
    m_FvxDisplayEx2->CreateDisplay(1,0);
	

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

// T[`̈̃eLXg\
void CAlignmentParamDlg::SetSearchRegionView(int index)
{
    IFvRectangle2Ptr pFvrect (__uuidof(FvRectangle));

	CEdit*    pedit;
	if (index == 0 ) {
		pedit = ( CEdit* )GetDlgItem( IDC_SEARCHAREA1 );
	} else {
		pedit = ( CEdit* )GetDlgItem( IDC_SEARCHAREA2 );
	}

    // ݂̐ݒl擾
    pMainDlg->GetSearchArea( index, pFvrect );
    if ( ( pFvrect->Getxs() == -1 ) && ( pFvrect->Getys() == -1 ) && ( pFvrect->Getxe() == -1 ) && ( pFvrect->Getye() == -1 )) {
        pedit->SetWindowText( "S" );
	} else {
        CString szStr;
		szStr.Format("(%.0f,%.0f)-(%.0f,%.0f)",pFvrect->Getxs(),pFvrect->Getys(),pFvrect->Getys(), pFvrect->Getye());
		pedit->SetWindowText( szStr );
	}

}

// OK{^
void CAlignmentParamDlg::OnOk() 
{
    
	UpdateData( TRUE );

    // p[^ݒ
    pMainDlg->m_FvxCorrelation1->PutSearchMode(( SEARCH_MODE_TYPE )m_searchmode );
    pMainDlg->m_FvxCorrelation2->PutSearchMode(( SEARCH_MODE_TYPE )m_searchmode );
    pMainDlg->m_FvxCorrelation1->PutPrecision (( PRECISION_TYPE )m_precision );
    pMainDlg->m_FvxCorrelation2->PutPrecision (( PRECISION_TYPE )m_precision );

    // 摜̏
    if (( m_condition < 1 ) || ( m_condition > 9 )) {
		MessageBox("摜Ԃ 1`9 ̊ԂŐݒ肵Ă","G[", MB_ICONWARNING | MB_OK);
		return;
	}

    pMainDlg->m_FvxCorrelation1->PutCondition ( m_condition );
    pMainDlg->m_FvxCorrelation2->PutCondition ( m_condition );
    
    // 臒l
	if (( m_threshold < 10 ) || ( m_threshold > 1000 )) {
		MessageBox("臒l 10`100 ̊Ԃœ͂Ă","G[", MB_ICONWARNING | MB_OK);
		return;
	}
    pMainDlg->m_FvxCorrelation1->PutScoreThresh ( m_threshold );
    pMainDlg->m_FvxCorrelation2->PutScoreThresh ( m_threshold );

    // r臒l
    if (( m_middlethreshold < 10 ) ||  ( m_middlethreshold > 1000 )) {
		MessageBox("r臒l 10`100 ̊Ԃœ͂Ă","G[", MB_ICONWARNING | MB_OK);
		return;
	}
    pMainDlg->m_FvxCorrelation1->PutScoreThresh2( m_middlethreshold );
    pMainDlg->m_FvxCorrelation2->PutScoreThresh2( m_middlethreshold );

    // ͈͐ڐGĂ̂o邩
    if ( m_wndtouch == 1 ) {
	    pMainDlg->m_FvxCorrelation1->PutWindowTouch(ON);
	    pMainDlg->m_FvxCorrelation2->PutWindowTouch(ON);
    } else {
	    pMainDlg->m_FvxCorrelation1->PutWindowTouch(OFF);
	    pMainDlg->m_FvxCorrelation2->PutWindowTouch(OFF);
	}

	pMainDlg->ParamDlgHide();

}

void CAlignmentParamDlg::OnSetpattern1() 
{
	Setpattern(0);
}

void CAlignmentParamDlg::OnSetpattern2() 
{
	Setpattern(1);
}

// p^o^
void CAlignmentParamDlg::Setpattern(int index)
{

    long isok = 0;
    IFvRectangle2Ptr pFvrect(__uuidof(FvRectangle));
    IFvPointPtr pFvpt(__uuidof(FvPoint));
		

	pFvxROI[index]->PutUsePoint(FALSE); 
	pFvxROI[index]->MakeROIDialog( pMainDlg->m_FvxGrabImage, &isok );
	if ( isok == 1 ) {

        // p^̈擾
        pFvxROI[index]->GetRectangle( pFvrect );
        
        // ʒm_Wp^̒Sɐݒ
        pFvpt->Putx( (pFvrect->Getxs() + pFvrect->Getxe()) / 2 );
        pFvpt->Puty( (pFvrect->Getys() + pFvrect->Getye()) / 2 );
        
        // p^쐬
        pMainDlg->pFvxAlignmentPattern[index]->MakePattern( pMainDlg->m_FvxGrabImage, pFvrect, pFvpt );
        
        // p^̕\
        if (index == 0) {
			m_FvxDisplayEx1->DrawImage( pMainDlg->pFvxAlignmentPattern[index] );
		} else {
			m_FvxDisplayEx2->DrawImage( pMainDlg->pFvxAlignmentPattern[index] );
		}
	}

}

void CAlignmentParamDlg::OnSetsearchregion1() {	Setsearchregion(0);}
void CAlignmentParamDlg::OnSetsearchregion2() {	Setsearchregion(1);}

// T[`̈ݒ
void CAlignmentParamDlg::Setsearchregion(int index)
{

    IFvRectangle2Ptr pFvrect(__uuidof(FvRectangle));
    long isok = 0;
    
    // ݂̐ݒl擾
    pMainDlg->GetSearchArea( index, pFvrect );
    
    if (( pFvrect->Getxs() == -1 ) && ( pFvrect->Getys() == -1 ) && ( pFvrect->Getxe() == -1 ) && ( pFvrect->Getye() == -1 )) {
        pFvrect->Putxs( 0 );
        pFvrect->Putys( 0 );
        pFvrect->Putxe( pMainDlg->m_FvxGrabImage->GetImageWidth() - 1 );
        pFvrect->Putye( pMainDlg->m_FvxGrabImage->GetImageHeight() - 1 );
	}
		
    // ̈I
    pFvxROIGSArea[index]->SetRectangle( pFvrect );
    pFvxROIGSArea[index]->MakeROIDialog( pMainDlg->m_FvxGrabImage, &isok );
    
    // ݒ̈̓Kp
    if ( isok == 1 ) {
        pFvxROIGSArea[index]->GetRectangle( pFvrect );
        pMainDlg->SetSearchArea( index, pFvrect );
        SetSearchRegionView( index );
	}

}

void CAlignmentParamDlg::OnDisppattern1() {	DispPattern(0);}
void CAlignmentParamDlg::OnDisppattern2() {	DispPattern(1);}

// p^̕\
void CAlignmentParamDlg::DispPattern(int index)
{
    pMainDlg->pFvxAlignmentPattern[index]->Disp(-1,-1);
}

void CAlignmentParamDlg::OnSetpatternmask1() { Setpatternmask(0);}
void CAlignmentParamDlg::OnSetpatternmask2() { Setpatternmask(1);}

// p^}XN̐ݒ
void CAlignmentParamDlg::Setpatternmask(int index)
{
    pMainDlg->pFvxAlignmentPattern[index]->DefMask( -1, -1 );
}

void CAlignmentParamDlg::OnLoadpattern1() {	Loadpattern(0);}
void CAlignmentParamDlg::OnLoadpattern2() {	Loadpattern(1);}

// T[`p^t@C̓ǂݎ
void CAlignmentParamDlg::Loadpattern(int index)
{

	char szFilters[]="pat file(*.pat)|*.pat||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "pat", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		try {
		
			pMainDlg->pFvxAlignmentPattern[index]->PutLoadPattrenFileName (_bstr_t(cFileDlg.GetPathName()));
			pMainDlg->pFvxAlignmentPattern[index]->Load();
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			pMainDlg->pFvxAlignmentPattern[index]->GetErrReport( &lngErr );
			cStr.Format("p^t@CǍG[ = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

        // p^̕\
        if (index == 0) {
			m_FvxDisplayEx1->DrawImage( pMainDlg->pFvxAlignmentPattern[index] );
		} else {
			m_FvxDisplayEx2->DrawImage( pMainDlg->pFvxAlignmentPattern[index] );
		}
	}
}

void CAlignmentParamDlg::OnSavepattern1() {	Savepattern(0);}
void CAlignmentParamDlg::OnSavepattern2() {	Savepattern(1);}

// T[`p^t@C̕ۑ
void CAlignmentParamDlg::Savepattern(int index)
{

	// R_CAONX̐
	char szFilters[]="pat file(*.pat)|*.pat||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "pat", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		try {
			pMainDlg->pFvxAlignmentPattern[index]->PutSavePattrenFileName (_bstr_t( cFileDlg.GetPathName() ));
			pMainDlg->pFvxAlignmentPattern[index]->Save();
			
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			pMainDlg->pFvxAlignmentPattern[index]->GetErrReport( &lngErr );
			cStr.Format("p^t@CǍG[ = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

void CAlignmentParamDlg::InitPtn()
{

	// ݒpRg[̏
	CComboBox*    pcmb;

	pcmb = ( CComboBox* )GetDlgItem( IDC_SEARCHMODE );
	pcmb->AddString( "ʏ̃p^[" );
	pcmb->AddString( "̃p^[" );
	pcmb->AddString( "̃p^[" );
	pcmb->AddString( "sp^[" );
	m_searchmode = pMainDlg->m_FvxCorrelation1->GetSearchMode();
    
	pcmb = ( CComboBox* )GetDlgItem( IDC_PRECISION );
	pcmb->AddString( "ʏ퐸x" );
	pcmb->AddString( "x" );
	pcmb->AddString( "x" );
    m_precision =  pMainDlg->m_FvxCorrelation1->GetPrecision();
    
    m_condition = pMainDlg->m_FvxCorrelation1->GetCondition();
    m_middlethreshold = pMainDlg->m_FvxCorrelation1->GetScoreThresh2();
    m_threshold = pMainDlg->m_FvxCorrelation1->GetScoreThresh();

	UpdateData( FALSE );
    
}

void CAlignmentParamDlg::PtnView()
{

	SetSearchRegionView( 0 );
    SetSearchRegionView( 1 );

	m_FvxDisplayEx1->DrawImage(pMainDlg->pFvxAlignmentPattern[0]);
	m_FvxDisplayEx2->DrawImage(pMainDlg->pFvxAlignmentPattern[1]);
}
